	include "ioequ.asm"

A_PAR		equ	10240		; Adresse des para. max: 6144.
OUT_Buf		equ	8192
OUT_Buf_mod	equ	2047
DMA_SIZE	equ	2048

DM_R_REQ	equ	$050001		;message -> host to request dma
VEC_R_DONE	equ	$0024		;host command indicating dma complete
DMA_DONE	equ	$0		;bit indiquant DMA finit.



;;;------------------------- Variable locations
;;;

x_sFlags	equ	$00ff		; dspstream flags
bull		equ	$00fe		; Auxiliary variable.
stereo		equ	$00fd		; stereo flag


;; INIT_INT interrupt addresses initializations.

INIT_I	MACRO

	org	p:$0			
	jmp	reset

	org	p:VEC_R_DONE
	bset	#DMA_DONE,x:x_sFlags
	
	org	p:$28			
	bset	#0,x:stereo			

	org	p:$2A			
	bset	#1,x:stereo			

	ENDM


; INPUT reads a sample into x:(R5). INPUT uses X0 and a!
;

INPUT	MACRO

	btst	#0,x:stereo
	jcc	_input_wait
_input_wait0
	jclr	#m_hrdf,x:m_hsr,_input_wait0
	move	x:m_hrx,X0		; get the sample
	move	X0,a
	jclr	#15,X0,_ooo0		; This is a modification which corrects
	move	#>$FF,a2		; the driver's "bug". It sign-extends
	move	#>$FF0000,X0		; the received short value,if necessary
	or	X0,a	
_ooo0					; now the correct value is in a.
	move	a,y:(R5)
	
_input_wait
	jclr	#m_hrdf,x:m_hsr,_input_wait
	move	x:m_hrx,X0		; get the sample
	move	X0,a
	jclr	#15,X0,_ooo		; This is a modification which corrects
	move	#>$FF,a2		; the driver's "bug". It sign-extends
	move	#>$FF0000,X0		; the received short value,if necessary
	or	X0,a	
_ooo					; now the correct value is in a.
	move	a,x:(R5)+
	
	ENDM
	
	
; OUTPUT writes a sample into the output buffer, and triggers a DMA out if
; necessary. Uses a, b, and updates R3.
	
OUTPUT	MACRO
	
	move	a,x:(R3)+
	btst	#0,x:stereo
	jcc	<_mono_out
	move	b,x:(R3)+
	jmp	<_output_test
_mono_out
	btst	#1,x:stereo
	jcc	<_output_test
	move	a,x:(R3)+
_output_test
	move	#>OUT_Buf,a
	move	R3,b
	cmp	a,b			; R3 - OUT_Buff
	jne	<_end_output		; if R3!= OUT_BUF, continue...
	
	
send_DMA				; There's a full DMA buffer.
	jclr	#m_htde,x:m_hsr,send_DMA
	movep	#DM_R_REQ,x:m_htx	; send "DSP_dm_R_REQ" to host
_ackBegin
	jclr	#m_hf1,x:m_hsr,_ackBegin	;    wait for HF1 to go high
	move	#>DMA_SIZE,b
	do	b,_prodDMA
	move	x:(R3)+,a		; and pass the values to the host.
_wait
	jclr	#m_htde,x:m_hsr,_wait
	move	a,x:m_htx	
_prodDMA
	btst	#DMA_DONE,x:x_sFlags
	jcs	_endDMA
	jclr	#m_htde,x:m_hsr,_prodDMA
	movep	#0,x:m_htx		;send zeros until noticed
	jmp	_prodDMA
_endDMA
	bclr	#DMA_DONE,x:x_sFlags	
_ackEnd

_end_output
	
	ENDM	


; IRSMPL initialize some parameters, pointers and stuff.

IRSMPL	MACRO

	move	#0,R2
			
	move	R2,R5
			
	move	R2,R7		
	move	#>251,M2
	move	#>251,M5
	clr	A
	rep	#256
	move	A,x:(R5)+
	move	A,x:(R5)+
	move	#>OUT_Buf,R3
	move	#>OUT_Buf_mod,M3
	move	R2,x:x_sFlags		;clear flags
	bclr	#0,x:stereo			
	bclr	#1,x:stereo			

	ENDM
	
	
; READPAR reads the conversion parameters passed by the host program.	
	
READPAR	MACRO
	move	#>A_PAR,R4
	do	#4,_end_para1		; Reads P,Q,K-1 and KP+2
_wait_para1
	jclr	#m_hrdf,x:m_hsr,_wait_para1
	move	x:m_hrx,a
	move	a,x:(R4)+
_end_para1	
	move	#>2,X0
	sub	X0,a			; a = KP
	do	a,_end_read		; Reads the KP filter coefficients.
_wait_para2
	jclr	#m_hrdf,x:m_hsr,_wait_para2
	move	x:m_hrx,a
	move	a,x:(R4)+
_end_read

	ENDM

