;
;****************************************************************
;		RSMPL						*
;****************************************************************
;
;	AUTEURS:		J. LAROCHE, JM. JOT
;	DATE DE MISE A JOUR:	06/06/91
;
;	OBJET DU MODULE: 	changement de Fe ( multipliee par P/Q )
;	Temps d'execution:
;
;	MEMOIRE X=Y:SON pointee par R0 (DIGITEC):
;	 L'echantillon d'entree X(n) est lu en memoire son.
;	 la sortie Y(n)= Sommme( X(n-i).H(i) ) pour i=0..Ordre
;	 est rangee  l'adresse suivante en memoire son.
;	*X=Y********* 
;   R0->*    X(n)   *	 entree (voie gauche en stereo)
;	*  [Xd(n)]  *	        (voie gauche en stereo)
;	*    Y(n)   *	 sortie (voie gauche en stereo)
;	*  [Yd(n)]  *	        (voie droite en stereo)
;	*************->R0
;
;	MEMOIRE X,Y:INTERNE pointee par R2 et R5
;	 X(n) est range dans dans un buffer circulaire en memoire interne
;	 pointee par R5 qui s'incremente a chaque periode d'echantillonnage modulo M5.
;	 Les echantillons d'entree precedents sont relus dans ce buffer
;	 pointes par R2, modulo M2.
;	***********X*Y***********
;	*           *           * debut du buffer circulaire
;	:           :           :
;       *   X(n-i)  * [Xd(n-i)] * <-R2 (pointeur de lecture des echantillons passes)
;	:           :           :
;       *   X(n-1)  * [Xd(n-1)] *
;   R5->*   X(n)    * [Xd(n)]   *
;	*           *           *->R5  (pointeur d'ecriture)
;	:           :           :
;	*           *           *
;	************************* fin du buffer circulaire
;
;	MEMOIRE X=Y:PARAMETRE pointee par R4
;   R4->*X=Y***********
;	*     P	      *
;	*     Q	      *
;	*    K-1      *
;	*    K.P      *
;       *    H(0)     *
;	*  [Hd(0)]    *
;	*    H(1)     *
;	*  [Hd(1)]    *
;	:             :
;	*   H(Ordre)  *
;	* [Hd(Ordre)] *			Ordre= K.P-1
;	***************->R4
;


	include	"next.asm"


	INIT_I				; Initialise les interruptions.

;; Debut de programme

	org	p:$100	

start
	IRSMPL				; Initialise la routine.
	READPAR				; Lit les parametres (filtre etc...)
		
main
_main_loop				; Here's the main loop!!

	RSMPL				; Macro qui fait tout!
	
	jmp	_main_loop		; until the cows come home.

reset
	movec   #6,omr			;data rom enabled, mode 2
	bset    #0,x:m_pbc		;host port
	bset	#3,x:m_pcddr		;   pc3 is an output with value
	bclr	#3,x:m_pcd		;   zero to enable the external ram
	movep   #>$000000,x:m_bcr	;no wait states on the external sram
        movep   #>$00BC00,x:m_ipr  	;intr levels: SSI=2, SCI=1, HOST=2
	bset    #m_hcie,x:m_hcr		;host command interrupts
	move	#0,sr			;enable interrupts
	jmp start
	
	DMA_IN				; subroutines for DMA_IN

