/*
 * FILE: fugue.h
 *   BY: Christopher Lee Fraley (cf0v@spice.cs.cmu.edu)
 * DESC: functions decls for sound manipulation functions.
 *
 * 1.0 (13-FEB-89) - created from "sound.h". (cf0v)
 * 1.1 (20-APR-89) - added logicalTo. (cf0v)
 *     (29-OCT-89) - added s_from, s_dur, s_to, s_logicalto (rbd)
 */

#ifndef SOUND_H
#include "sound.h"
#endif

float	  s_maxSample();	/* LISP: (S-MAXSAMP SOUND)		  */
float     s_from();             /* LISP: (S-FROM SOUND)                   */
float     s_dur();              /* LISP: (S-DUR SOUND)                    */
float     s_to();               /* LISP: (S-TO SOUND)                     */
LVAL      s_samples();          /* LISP: (S-SAMPLES SOUND FIXNUM)         */
SoundPtr  s_show();             /* LISP: (S-SHOW SOUND)                   */
float     s_srate();            /* LISP: (S-SRATE SOUND)                  */
SoundPtr  s_stats();		/* LISP: (S-STATS SOUND)		  */
float     s_access();           /* LISP: (S-ACCESS SOUND FLONUM)          */
SoundPtr  s_apply();		/* LISP: (S-APPLY SOUND FLONUM FLONUM FLONUM FLONUM FLONUM FLONUM) */
SoundPtr  s_scale();		/* LISP: (S-SCALE SOUND FLONUM)		  */
SoundPtr  s_clip();		/* LISP: (S-CLIP SOUND FLONUM FLONUM)	  */
SoundPtr  s_lclip();		/* LISP: (S-LCLIP SOUND FLONUM)		  */
SoundPtr  s_rclip();		/* LISP: (S-RCLIP SOUND FLONUM)		  */
SoundPtr  s_shift();		/* LISP: (S-SHIFT SOUND FLONUM)		  */
SoundPtr  s_stretch();		/* LISP: (S-STRETCH SOUND FLONUM)	  */
SoundPtr  s_add();		/* LISP: (S-ADD SOUND SOUND)		  */
SoundPtr  s_mult();		/* LISP: (S-MULT SOUND SOUND)		  */
SoundPtr  s_osc();		/* LISP: (S-OSC SOUND FLONUM FLONUM FLONUM FLONUM FLONUM FIXNUM) */
SoundPtr  s_env();		/* LISP: (S-ENV FLONUM FLONUM FLONUM FLONUM FLONUM FLONUM FLONUM FLONUM) */
SoundPtr  s_pwl();              /* LISP: (S-PWL FLONUM ANY) */
SoundPtr  sf_load();		/* LISP: (SF-LOAD STRING FLONUM)	  */
SoundPtr  sf_save();		/* LISP: (SF-SAVE SOUND STRING)		  */
double	  step_to_hz();		/* LISP: (STEP-TO-HZ FLONUM)		  */
double	  hz_to_step();		/* LISP: (HZ-TO-STEP FLONUM)		  */
double    s_logicalTo();        /* LISP: (S-LOGICALTO SOUND)              */
SoundPtr  s_setLogicalTo();     /* LISP: (S-SETLOGICALTO FLONUM SOUND)    */
double    log();                /* LISP: (LOG FLONUM) */
