;;;
;;;   ####################################################
;;;   ### FUGUE-- A Sound-Sample Composition Language. ###
;;;   ####################################################
;;;
;;; FILE: fugue.lsp
;;;   BY: Christopher Lee Fraley (cf0v@spice.cs.cmu.edu)
;;; FROM: /../spice/rbd/src/lisp/canon/canon.lsp
;;;	  Roger B. Dannenberg's "Canon":
;;;		Canon-- a score language
;;;		Copyright (c)1988, Roger B. Dannenberg
;;;		10-Jan-88
;;;
;;; 1.0 (13-FEB-89) - created from canon.lsp. (cf0v)
;;; 1.1 (25-FEB-89) - complete primitives. (cf0v)
;;; 1.2 (20-APR-89) - logicalTo added. (cf0v)
;;; 1.3 ( 5-MAY-89) - new s-osc(); *OSC* is now (sound . key). (cf0v)
;;;

(prog ()
   (setq lppp 0.33) (setq lpp 0.50)  (setq lp 0.75)    (setq lmp 0.90)
   (setq lfff 3.00) (setq lff 2.00)  (setq lp 1.33)    (setq lmf 1.11)
   (setq dB0 1.00)  (setq dB1 1.122) (setq dB10 3.1623)

   (setq s 0.25) (setq sd 0.375) (setq st (/ 0.5 3.0))
   (setq i 0.5)  (setq id 0.75)  (setq it (* st 2.0))
   (setq q 1.0)  (setq qd 1.5)   (setq qt (* st 4.0))
   (setq h 2.0)  (setq hd 3.0)   (setq ht (* st 8.0))
   (setq w 4.0)  (setq wd 6.0)   (setq wd (* st 16.0))
)



(prog ()
   (setq no-pitch 116.0)

   (setq c0   0.0) (setq cs0 1.0) (setq df0  1.0) (setq d0   2.0)
   (setq ds0  3.0) (setq ef0 3.0) (setq e0   4.0) (setq f0   5.0)
   (setq fs0  6.0) (setq gf0 6.0) (setq g0   7.0) (setq gs0  8.0)
   (setq af0  8.0) (setq a0  9.0) (setq as0 10.0) (setq bf0 10.0)
   (setq b0  11.0)

   (setq c1  12.0) (setq cs1 13.0) (setq df1 13.0) (setq d1  14.0)
   (setq ds1 15.0) (setq ef1 15.0) (setq e1  16.0) (setq f1  17.0)
   (setq fs1 18.0) (setq gf1 18.0) (setq g1  19.0) (setq gs1 20.0)
   (setq af1 20.0) (setq a1  21.0) (setq as1 22.0) (setq bf1 22.0)
   (setq b1  23.0)

   (setq c2  24.0) (setq cs2 25.0) (setq df2 25.0) (setq d2  26.0)
   (setq ds2 27.0) (setq ef2 27.0) (setq e2  28.0) (setq f2  29.0)
   (setq fs2 30.0) (setq gf2 30.0) (setq g2  31.0) (setq gs2 32.0)
   (setq af2 32.0) (setq a2  33.0) (setq as2 34.0) (setq bf2 34.0)
   (setq b2  35.0)

   (setq c3  36.0) (setq cs3 37.0) (setq df3 37.0) (setq d3  38.0)
   (setq ds3 39.0) (setq ef3 39.0) (setq e3  40.0) (setq f3  41.0)
   (setq fs3 42.0) (setq gf3 42.0) (setq g3  43.0) (setq gs3 44.0)
   (setq af3 44.0) (setq a3  45.0) (setq as3 46.0) (setq bf3 46.0)
   (setq b3  47.0)

   (setq c4  48.0) (setq cs4 49.0) (setq df4 49.0) (setq d4  50.0)
   (setq ds4 51.0) (setq ef4 51.0) (setq e4  52.0) (setq f4  53.0)
   (setq fs4 54.0) (setq gf4 54.0) (setq g4  55.0) (setq gs4 56.0)
   (setq af4 56.0) (setq a4  57.0) (setq as4 58.0) (setq bf4 58.0)
   (setq b4  59.0)

   (setq c5  60.0) (setq cs5 61.0) (setq df5 61.0) (setq d5  62.0)
   (setq ds5 63.0) (setq ef5 63.0) (setq e5  64.0) (setq f5  65.0)
   (setq fs5 66.0) (setq gf5 66.0) (setq g5  67.0) (setq gs5 68.0)
   (setq af5 68.0) (setq a5  69.0) (setq as5 70.0) (setq bf5 70.0)
   (setq b5  71.0)

   (setq c6  72.0) (setq cs6 73.0) (setq df6 73.0) (setq d6  74.0)
   (setq ds6 75.0) (setq ef6 75.0) (setq e6  76.0) (setq f6  77.0)
   (setq fs6 78.0) (setq gf6 78.0) (setq g6  79.0) (setq gs6 80.0)
   (setq af6 80.0) (setq a6  81.0) (setq as6 82.0) (setq bf6 82.0)
   (setq b6  83.0)

   (setq c7  84.0) (setq cs7 85.0) (setq df7 85.0) (setq d7  86.0)
   (setq ds7 87.0) (setq ef7 87.0) (setq e7  88.0) (setq f7  89.0)
   (setq fs7 90.0) (setq gf7 90.0) (setq g7  91.0) (setq gs7 92.0)
   (setq af7 92.0) (setq a7  93.0) (setq as7 94.0) (setq bf7 94.0)
   (setq b7  95.0)

   (setq c8   96.0) (setq cs8  97.0) (setq df8  97.0) (setq d8   98.0)
   (setq ds8  99.0) (setq ef8  99.0) (setq e8  100.0) (setq f8  101.0)
   (setq fs8 102.0) (setq gf8 102.0) (setq g8  103.0) (setq gs8 104.0)
   (setq af8 104.0) (setq a8  105.0) (setq as8 106.0) (setq bf8 106.0)
   (setq b8  107.0)
)



(setf *DEFAULT-SOUND-SRATE* 22050.0)

(setf *SINE-TABLE* (sf-load "sine.snd" *DEFAULT-SOUND-SRATE*))

;; GLOBAL ENVIRONMENT VARIABLES and their startup values:
(defun environment-init ()
  (setq *TIME*		0.0)
  (setq *VOLUME*	1.0)
  (setq *TRANSPOSE*	0.0)
  (setq *STRETCH*	1.0)
  (setq *DUTY*	        1.0)
  (setq *START*       -1e+9)
  (setq *STOP*         1e+9)
  (setq *CNTRL-SRATE*  2205.0)
  (setq *SOUND-SRATE* *DEFAULT-SOUND-SRATE*)
  ; this has 2048 samples, so compute the step number from that:
  (setq *OSC* (cons *SINE-TABLE*
		    (hz-to-step (/ *SOUND-SRATE* 2048.0)))))

(environment-init)
  

;; abs -- restore the standard environment
;;
(defmacro abs (s)
  `(let (($old-time *TIME*)
	 ($old-vol *VOLUME*)
	 ($old-trans *TRANSPOSE*)
	 ($old-stretch *STRETCH*)
	 ($old-duty *DUTY*)
	 ($old-start *START*)
	 ($old-stop *STOP*)
	 ($old-cntrl *CNTRL-SRATE*)
	 ($old-sound *SOUND-SRATE*)
	 $snd)
     (environment-init)
     (setf $snd ,s)
     ; restore environment
     (setf *TIME* $old-time)
     (setf *VOLUME* $old-vol)
     (setf *TRANSPOSE* $old-trans)
     (setf *STRETCH* $old-stretch)
     (setf *DUTY* $old-duty)
     (setf *START* $old-start)
     (setf *STOP* $old-stop)
     (setf *CNTRL-SRATE* $old-cntrl)
     (setf *SOUND-SRATE* $old-sound)
     ; return the sound
     $snd))
     

;; (cue sound)
;;    Cues the given sound; that is, it applies the current *TIME*, *VOLUME*,
;; *START*, and *STOP* values to the argument.
(defun cue (sound)
      (s-apply sound *VOLUME* (- *START* *TIME*) (- *STOP* *TIME*)
	     *TIME* 1.0 0.0))


;; (sound sound)
;;    Same as (cue sound), except also applies *STRECTH*, *SOUND-SRATE*, etc.
;; That is, this applies ALL of the APPLICABLE current environmental variables
;; to a sound.  Note that the *SOUND-SRATE* will not change the pitch of the
;; sound, it merely will change its internal sample-rate.
(defun sound (sound)
   (s-apply sound *VOLUME* (/ (- *START* *TIME*) *STRETCH*)
      (/ (- *STOP* *TIME*) *STRETCH*)
      (/ *TIME* *STRETCH*) *STRETCH* *SOUND-SRATE*))


;; (control sound)
;;    Same as (sound sound), except this is used for control signals.  Hence
;; *CNTRL-SRATE* is used instead of *SOUND-SRATE*. That is, this applies ALL
;; of the APPLICABLE current environmental variables to a "control" sound.
;; Note that we want the clip times *START* and *STOP* to apply AFTER the
;; shift and stretch operations, so we have to undo the mapping that will
;; be performed by s-apply:
(defun control (sound)
   (s-apply sound 1.0 (/ (- *START* *TIME*) *STRETCH*)
      (/ (- *STOP* *TIME*) *STRETCH*)
      (/ *TIME* *STRETCH*) *STRETCH* *CNTRL-SRATE*))


;; (sfload string)
;;    Loads a sound file with the given name, returning a sound which is
;; transformed to the current environment.
(defun sfload (name)
   (cue (sf-load  name *SOUND-SRATE*)))



;; (env t1 t2 t4 l1 l2 l3 &optional duration)
;; Creates a 4-phase envelope.
;;	tN is the duration of phase N, and lN is the final level of
;;	phase N.  t3 is implied by the duration, and l4 is 0.0.
;;	If dur is not supplied, then 1.0 is assumed.  The envelope
;;	duration is the product of dur, *STRETCH*, and *DUTY*.  If 
;;	t1 + t2 + 2ms + t4 > duration, then a two-phase envelope is
;;	substituted that has an attack/release time ratio = t1/t4.
;;	The sample rate of the returned sound is *CNTRL-SRATE*.
(defun env (t1 t2 t4 l1 l2 l3 &optional duration)
  (let (actual-dur min-dur ratio t3)
    (if (null duration) (setf duration 1.0))
    (setf actual-dur (* duration *STRETCH* *DUTY*))
    (setf min-dur (+ t1 t2 t4 0.002))
    (cond ((< actual-dur min-dur)
	   (setf ratio (/ t1 (+ t1 t4)))
	   (setf t1 (* ratio actual-dur))
	   (setf t2 (- actual-dur t1))
	   (setf t3 0.0)
	   (setf t4 0.0)
	   (setf l2 0.0)
	   (setf l3 0.0))
	  (t
	   (setf t3 (- actual-dur t1 t2 t4))))
    ;; envelope is "pre-stretched", so use s-apply, not control:
    (s-apply (s-env *CNTRL-SRATE* t1 t2 t3 t4 l1 l2 l3)
	     1.0 (- *START* *TIME*) (- *STOP* *TIME*) *TIME* 1.0 
	     *CNTRL-SRATE*)))


;; (osc canon-pitch &optional duration oneShot sound phase)
;;    Default duration is 1.0 sec, default sound is *OSC*, default phase is
;; 0.0.  Units of phase is dertermined at compile time.  Set oneShot to
;; (fixnum)1, if you want sound to become a one-shot sound sample.
(defun osc (pitch &optional (duration 1.0) (oneShot 0)
			    (sound *OSC*) (phase 0.0))
   (cue (s-osc (car sound) (cdr sound) *SOUND-SRATE*
      (step-to-hz (+ pitch *TRANSPOSE*)) (* duration *STRETCH*)
      phase oneShot)))


;; (lfo freq &optional duration oneShot sound phase)
;;    Default duration is 1.0 sec, default sound is *OSC*, default phase is
;; 0.0.  Units of phase is dertermined at compile time.  Set oneShot to
;; (fixnum)1, if you want sound to become a one-shot sound sample.
(defun lfo (freq &optional (duration 1.0) (oneShot 0)
			    (sound *OSC*) (phase 0.0))
   (cue (s-osc (car sound) (cdr sound) *CNTRL-SRATE*
      freq (* duration *STRETCH*) phase oneShot)))



(defun fmosc (pitch modulation &optional (one-shot 0) (osc *osc*) (phase 0.0))
  (cue (s-fmosc (car osc) (cdr osc) *SOUND-SRATE*
		(step-to-hz (+ pitch *TRANSPOSE*))
		modulation phase one-shot)))


;; (note canon-pitch &optional duration env duty volume sound)
;;    Creates a note with the given characteristics.  Default duration is
;; 1.0 seconds, duty is 1.0, volume is 1.0, sound is *OSC*.  Env may be
;; a list of 4 envelope time constants and 3 levels, or env may be a sound.
(defun note (pitch &optional (duration 1.0) env (duty 1.0) (volume 1.0)
			     (sound *OSC*) (oneShot 0))
   (cond ((null env) (loud volume (osc pitch duration oneShot sound)))
	 ((listp env) (note pitch duration (eval (cons 'env env))
			    duty volume sound))
	 (t (s-mult (loud volume env) (osc pitch duration oneShot sound)))))


;; (pwl t1 l1 t2 l2 ... tn)
;;   Creates a piece-wise linear envelope from breakpoint data.
;;
(defun pwl (&rest breakpoints)
  (control (setf last-pwl (s-pwl *CNTRL-SRATE* breakpoints))))



(defmacro at (x s)
 `(let (($start *TIME*))
    (prog2
      (setq *TIME* (+ *TIME* (* *STRETCH* ,x)))
      ,s
      (setq *TIME* $start))))


(defmacro at-abs (x s)
 `(let (($start *TIME*))
    (prog2
      (setq *TIME* ,x)
      ,s
      (setq *TIME* $start))))


(defmacro extract (start stop sound)
 `(let (($oldstart *START*) ($oldstop *STOP*) ($oldtime *TIME*) 
	($newstart (* *STRETCH* ,start)) 
	($newstop  (* *STRETCH* ,stop)) 
	$newsound)
    (setq *START* (+ *TIME* $newstart))
    (setq *STOP*  (+ *TIME* $newstop))
    (setq $newsound ,sound)
    (setq *START* $oldstart)
    (setq *STOP* $oldstop)
    (setq *TIME* $oldtime)
    (at-abs (- $newstart) (cue $newsound))))


(defmacro extract-abs (start stop sound)
 `(let (($oldstart *START*) ($oldstop *STOP*) 
	($newstart ,start)
	($newstop  ,stop) 
	$newsound)
    (setq *START* $newstart)
    (setq *STOP*  $newstop)
    (setq $newsound ,sound)
    (setq *START* $oldstart)
    (setq *STOP* $oldstop)
    (at-abs (- *TIME* $newstart) (cue $newsound))))



(defmacro loud (x s)
 `(let (($loudness *VOLUME*))
    (prog2 
      (setq *VOLUME* (* *VOLUME* ,x))
      ,s
      (setq *VOLUME* $loudness))))


(defmacro loud-abs (x s)
 `(let (($loudness *VOLUME*))
    (prog2
      (setq *VOLUME* ,x)
      ,s
      (setq *VOLUME* $loudness))))


(defmacro stretch (x s)
 `(let (($dur *STRETCH*))
    (prog2 
      (setq *STRETCH* (* *STRETCH* ,x))
      ,s
      (setq *STRETCH* $dur))))


(defmacro stretch-abs (x s)
 `(let (($dur *STRETCH*))
    (prog2
      (setq *STRETCH* ,x)
      ,s
      (setq *STRETCH* $dur))))


(defmacro sustain (x s)
 `(let (($duty *DUTY*))
    (prog2 
      (setq *DUTY* (* *DUTY* ,x))
      ,s
      (setq *DUTY* $duty))))


(defmacro sustain-abs (x s)
 `(let (($duty *DUTY*))
    (prog2
      (setq *DUTY* ,x)
      ,s
      (setq *DUTY* $duty))))


(defmacro trans (x s)
 `(let (($transpose *TRANSPOSE*))
    (prog2 
      (setq *TRANSPOSE* (+ *TRANSPOSE* ,x))
      ,s
      (setq *TRANSPOSE* $transpose))))


(defmacro trans-abs (x s)
 `(let (($transpose *TRANSPOSE*))
    (prog2
      (setq *TRANSPOSE* ,x)
      ,s
      (setq *TRANSPOSE* $transpose))))



(defmacro endTime (sound)
   `(s-logicalTo ,sound))


(defmacro beginTime (sound)
   `(car (s-extent ,sound)))


(defmacro seq (&rest sounds)
   (let ((body
	  (mapcar (lambda (s)
		     (list 'setq '*TIME*
			`(endTime (setq $snd (s-add $snd ,s))))) sounds)))
      (cons 'let
	 (cons '(($start *TIME*) ($snd (s-create)))
	    (nconc body '((setq *TIME* $start)
			  $snd))))))
      

(defmacro seqrep (pair sound)
   `(let (($start *TIME*) ($snd (s-create)))
       (dotimes ,pair (setq *TIME* (endTime (setq $snd (s-add $snd ,sound)))))
       (setq *TIME* $start)
       $snd))


(defmacro sim (&rest sounds)
   (let ((body
	  (mapcar (lambda (s)
			`(setq $snd (s-add $snd ,s))) sounds)))
      (cons 'let
	 (cons '(($start *TIME*) ($snd (s-create)))
	    (nconc body '((setq *TIME* $start)
			  $snd))))))


(defmacro simrep (pair sound)
   `(let (($snd (s-create)))
       (dotimes ,pair (setf $snd (s-add $snd ,sound)))
       $snd))


(defun rest (&optional (dur 1.0))
   (cue (s-setLogicalTo dur (s-create))))


(format t "~%Fugue-- A Sound-Sample Composition Language~%")
(format t "    By: Christopher Lee Fraley~%")
(format t "    Based upon 'Canon': Copyright (c)1988, by Roger B. Dannenberg~%")
