;;;
;;; FILE: sound.lsp
;;;   BY: Christopher Lee Fraley
;;; DESC: Lisp support code for the X-Lisp sound system.
;;;
;;; 1.0 (10-FEB-89) - created. (cf0v)
;;;


;; GLOBAL ENVIRONMENT VARIABLES and their startup values:
(setq *TIME*    0.0)
(setq *STRETCH* 1.0)
(setq *VOLUME*  1.0)
(setq *START*   0.0)
(setq *STOP*    0.0)
(setq *DUTY*    1.0)


;; (sfload string)
;;    Loads a sound file with the given name, returning a sound which is
;; transformed to the current environment.

(defun sfload (x)
   (s-scale
      (s-clip
         (s-shift
            (s-stretch (sf-load x) *STRETCH*)
	    *TIME*)
	 *START* *STOP*)
      *VOLUME*))


