;;; EXAMPLE 3 - using an envelope

; NOTE: this example assumes that "demo2.lsp" has been loaded!

; env-note produces an enveloped note.  The duration defaults to 1.0, but
;    stretch can be used to change the duration.
;
(defun env-note (p)
  (s-mult (note p 1.0)
	  (env 0.05 0.1 0.5 1.0 0.5 0.4)))


; try it out:
;
(play (env-note c4))


; now use stretch to play different durations
;
(play (seq (stretch 0.25 
		    (seq (env-note c4)
			 (env-note d4)))
	   (stretch 0.5 
		    (seq (env-note f4)
			 (env-note g4)))
	   (env-note c4)))

