(defun l () (load "icmc89"))

(defun sample (pitch source)
  (stretch-abs 1.0
	       (at-abs 0.0 (osc pitch (* (s-dur (car source)) 0.71
					 (canon-to-hz (cdr source))
					 (/ 1.0 (canon-to-hz pitch)))
				0 source))))

(defun nt (pitch)
  (let ((mysnd (sample (+ *transpose* pitch) bn-sample)))
    (warp-sound mysnd)))

(setf snipit-length 0.1)

(defun warp-sound (mysnd)
  (let ((n (1+ (truncate (* 2.0 (/ (- *stretch* snipit-length) snipit-length))))))
    (stretch-abs 1.0
		 (simrep (i n)
			 (snipit mysnd i n snipit-length)))))

(defun snipit (mysnd i n sl)
  (let* ((extract-from (* (- (s-dur mysnd) sl)
			  (/ (float i) (float n))))
	 (shift-amt (* (/ sl 2.0) i))
	 (rand-str (+ 1.0 (/ (- (random 20) 10) 500.0))))
    (format t "rand-str is ~A, shift-amt is ~A, extract-from is ~A~%" 
	    rand-str shift-amt extract-from)
    (at shift-amt 
	(stretch rand-str
		 (s-mult
		  (env (/ sl 2.0) (/ sl 2.0) 0.0 0.0 1.0 0.0 0.0)
		  (extract extract-from (+ extract-from sl) 
			   (control mysnd)))))))


(cond ((not (boundp 'bn)) 
       (setf bn (sf-load "bass.snd" 22050.0))
       (setf bn-sample (cons bn cs4))))
  

(defun tune1 ()
  (sim
   (nt c4)
   (at 1.0 (stretch 0.5 (nt c5)))
   (at 2.0 (stretch 2.0 (nt c6)))))

(defun tune2 ()
  (stretch 4.0
	   (sim
	    (at 0.0 (stretch 1.4 (nt g2)))
	    (at 0.39 (stretch 0.36 (nt g3)))
	    (at 0.71 (stretch 0.40 (nt cs3)))
	    (at 0.99 (stretch 0.32 (nt bf3))))))


(defun tune3 ()
  (sim
   (at 0.0 (cue bn))
   (at 2.0 (stretch 4.0 (nt g1)))
   (at 3.0 (stretch 6.0 (nt g2)))))

;(setf x (tune3))
;(play x)


